<template>
  <v-card outlined flat class="mt-2 panel">
    <v-row class="pl-5 pr-5" style="margin: 0px;"></v-row>
    <v-row class="pl-5 pr-5" style="margin: 0px;">
      <v-col sm="4">
        <erp-client-select v-model="request.client_id" />
      </v-col>
      <v-spacer />
      <v-col sm="4">
        <v-text-field
          class="search-bar"
          v-model="search"
          prepend-inner-icon="mdi-magnify"
          label="Kërko"
          single-line
          hide-details
          clearable
        />
      </v-col>
    </v-row>
    <v-data-table
      dense
      :headers="headers"
      :items="data"
      item-key="invoice_no"
      :items-per-page="15"
      :loading="loading"
      :options.sync="pagination"
      :server-items-length="totalRecords"
      outlined
      show-select
      @item-selected="rowSelected"
      v-model="selected"
    />
    <portal to="destination">
      <div class="portal-wrapper">
        <h3>
          Kartela e Klientit
        </h3>
      </div>
    </portal>
    <portal to="cto-topmenu">
      <div style="display: flex; align-content: center;">
        <download-excel
          class="export-button ma-2"
          :data="dataToExport"
          :fields="exportFields"
          worksheet="Kartela_e_Klientit"
          :name="`Kartela_e_klientit_${todayDate}`"
        >
          Eksporto<v-icon right dark small>mdi-file-download</v-icon>
        </download-excel>
      </div>
    </portal>
  </v-card>
</template>
<script lang="ts">
import { Component, Mixins, Watch } from 'vue-property-decorator'
import api from '../../../plugins/api'
import Table from '../../../plugins/table'
import ErpClientSelect from '../../../components/selects/ErpClientSelect.vue'

const datatableHeader = [
  {
    value: 'invoice_no',
    text: 'Fatura',
    sortable: false,
  },
  {
    value: 'type',
    text: 'Tipi',
    sortable: false,
  },
  {
    value: 'date',
    text: 'Data',
    sortable: false,
  },
  {
    value: 'debit',
    text: 'Vlera e Debitit',
    sortable: false,
  },
  {
    value: 'credit',
    text: 'Vlera e Kreditit',
    sortable: false,
  },
  {
    value: 'currency',
    text: 'Monedha',
    sortable: false,
  },
  {
    value: 'exchange_rate',
    text: 'Kursi i Kembimit',
    sortable: false,
  },
  {
    value: 'notes',
    text: 'Shenimet',
    sortable: false,
  },
  {
    value: 'receipt_value',
    text: 'Vlera e mandatit',
    sortable: false,
  },
  {
    value: 'receipt_unreconciled_value',
    text: 'Vlera e parekonsiluar',
    sortable: false,
  },
]

const exelHeaders = {
  Fatura: 'invoice_no',
  Tipi: 'type',
  Data: 'date',
  'Vlera e Debitit': 'debit',
  'Vlera e Kreditit': 'credit',
  Monedha: 'currency',
  'Kursi i Kembimit': 'exchange_rate',
}

@Component({
  components: { ErpClientSelect },
})
export default class ClientsJournal extends Mixins(Table) {
  @Watch('request.client_id')
  onClientIdChange() {
    this.fetchData()
  }
  headers = datatableHeader
  selected = []
  data = []
  request = {
    client_id: null,
  }
  exportFields = exelHeaders
  todayDate = new Date().toLocaleDateString('en-gb')

  get dataToExport() {
    return this.selected.length != 0 ? this.selected : this.data
  }
  prepareQueryParams() {
    const filters = JSON.stringify({ ...this.request })

    return { filters }
  }

  fetchData() {
    const query = this.prepareQuery(this.prepareQueryParams())
    this.loading = true
    api()
      .get(`/api/report-management/clients/cartel/${query}`)
      .then(response => {
        this.data = response.data.data
        this.totalRecords = response.data.meta.total
        console.log(response.data)
      })
      .finally(() => {
        this.loading = false
      })
  }
  rowSelected() {
    // this.$nextTick(() => {
    //   console.log(this.selected)
    // })
  }
}
</script>

<style scoped>
.export-button {
  background-color: #30488b;
  text-transform: uppercase;
  font-size: 80%;
  font-weight: 500;
  color: white;
  padding: 5px 10px;
  border-radius: 5px;
  cursor: pointer;
}
.export-button:hover {
  background-color: rgb(48, 72, 139, 0.95);
}
</style>
